#include "StdAfx.h"
#include "ScrollBarTimer.h"

static const int INVALID_TIMER_ID = -1;
CNScrollBarTimer::CNScrollBarTimer(void)
{
	m_dwTimerID = INVALID_TIMER_ID;
}

CNScrollBarTimer::~CNScrollBarTimer(void)
{
	_Destroy();
}
BOOL CNScrollBarTimer::SetTimer(DWORD dwStartDueTime, DWORD dwPeriod, DWORD dwTid, INPTimerHandler* pHandler, ULONG uFlag)
{
	BOOL bSuccess = _Create();
	ATLASSERT(bSuccess);
	if (!bSuccess) return bSuccess;
	Sleep(dwStartDueTime);
	m_dwTimerID = dwTid;
	m_pTimerHandler = pHandler;

	bSuccess = 0 != CWindowImpl<CNScrollBarTimer>::SetTimer(dwTid, dwPeriod, NULL);

	return bSuccess;
}
BOOL CNScrollBarTimer::StopTimer()
{
	if (IsWindow())
	{
		CWindowImpl<CNScrollBarTimer>::KillTimer(m_dwTimerID);
		m_dwTimerID = INVALID_TIMER_ID;
		//_Destroy();
		return TRUE;
	}
	return FALSE;	
}
BOOL CNScrollBarTimer::IsRunning()
{
	//return IsWindow();
	return (m_dwTimerID != INVALID_TIMER_ID);
}
BOOL CNScrollBarTimer::_Create()
{
	BOOL bSuccess = IsWindow();
	if (bSuccess)
	{
		return bSuccess;
	}
	CWindowImpl<CNScrollBarTimer>::Create(HWND_MESSAGE);
	bSuccess = IsWindow();
	return bSuccess;
}
BOOL CNScrollBarTimer::_Destroy()
{
	if (IsWindow())
	{
		DestroyWindow();		
	}
	return TRUE;
}
IMPLEMENT_MESSAGE_HANDLER(CNScrollBarTimer, OnTimer)
{
	if (wParam == m_dwTimerID)
	{
		ATLASSERT(m_pTimerHandler);
		m_pTimerHandler->OnTimer(m_dwTimerID);
	}
	return 0;
}

void CNScrollBarTimer::WaitForStop()
{
	MSG msg;
	while (TRUE)
	{
		if (this->IsRunning() == FALSE) break;

		if (::PeekMessage(&msg, NULL, WM_TIMER, WM_TIMER, PM_REMOVE) ||
			::PeekMessage(&msg, NULL, WM_PAINT, WM_PAINT, PM_REMOVE)) 
		{				
			::TranslateMessage(&msg);
			::DispatchMessage(&msg);
		}
	}
}